// *****************************************************************
// *                                                               *
// *       Copyright (c) Fast Corporation, 2005                    *
// *                                                               *
// *   All Rights Reserved.  Unpublished rights  reserved  under   *
// *   the copyright laws of the Japan.                            *
// *                                                               *
// *   The software contained on this media  is  proprietary  to   *
// *   and  embodies  the  confidential  technology  of  Fast      *
// *   Corporation.  Possession, use,  duplication  or             *
// *   dissemination of the software and media is authorized only  *
// *   pursuant to a valid written license from Fast Corporation.  *
// *                                                               *
// *****************************************************************

// -------------------------------------------------------------------
// FVX Sample Program
// 
//
// 쐬 : K.Yakushinji
//    : 2005/08/08 
//
//-------------------------------------------------------------------
// ChangeImageDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "ChangeImage.h"
#include "ChangeImageDlg.h"
#include "LicenceDlg.h"
#include "ConfFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// AvP[Ṽo[WŎgĂ CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard ͉z֐̃I[o[Ch𐶐܂
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

// Cve[V
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// bZ[W nh܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChangeImageDlg _CAO

CChangeImageDlg::CChangeImageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChangeImageDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChangeImageDlg)
	m_autobin = 0;
	m_dispimage = 0;
	m_staticparam1 = _T("");
	m_staticparam2 = _T("");
	m_staticparam3 = _T("");
	m_param1 = 0;
	m_param2 = 0;
	m_param3 = 0;
	m_executetime = _T("");
	//}}AFX_DATA_INIT
	// : LoadIcon  Win32  DestroyIcon ̃TuV[PXv܂B
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_blnVideoOpened = false;
}

void CChangeImageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChangeImageDlg)
	DDX_Control(pDX, IDC_BUTTON3, m_test);
	DDX_CBIndex(pDX, IDC_AUTOBIN, m_autobin);
	DDX_CBIndex(pDX, IDC_DISPIMAGE, m_dispimage);
	DDX_Text(pDX, IDC_STATICPARAM1, m_staticparam1);
	DDX_Text(pDX, IDC_STATICPARAM2, m_staticparam2);
	DDX_Text(pDX, IDC_STATICPARAM3, m_staticparam3);
	DDX_Text(pDX, IDC_PARAM1, m_param1);
	DDX_Text(pDX, IDC_PARAM2, m_param2);
	DDX_Text(pDX, IDC_PARAM3, m_param3);
	DDX_Text(pDX, IDC_EXECUTETIME, m_executetime);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChangeImageDlg, CDialog)
	//{{AFX_MSG_MAP(CChangeImageDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_SAVEIMAGE, OnSaveimage)
	ON_CBN_SELCHANGE(IDC_AUTOBIN, OnSelchangeAutobin)
	ON_CBN_SELCHANGE(IDC_DISPIMAGE, OnSelchangeDispimage)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_EXECUTE, OnExecute)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChangeImageDlg bZ[W nh

BOOL CChangeImageDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "o[W..." j[ڂVXe j[֒ǉ܂B

	// IDM_ABOUTBOX ̓R}h j[͈̔͂łȂ΂Ȃ܂B
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ̃_CAOp̃ACRݒ肵܂Bt[[N̓AvP[ṼC
	// EBhE_CAOłȂ͎Iɐݒ肵܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACRݒ
	SetIcon(m_hIcon, FALSE);		// ACRݒ
	
	// TODO: ʂȏs͂̏ꏊɒǉĂB
	/* -------------------------------------------------------------------------------- */
	// FvxSample 
	CLicenceDlg dlg;
	CConfFileDlg fdlg;

	// CZXʂ̕\
	if (dlg.DoModal() == IDOK){

		//Ӂ
		// ߂COM̏sƂYȂłB
		CoInitialize( NULL );
		CWnd *pwnd ;
		IUnknown *p_unknown;
		long err_no = 0 ;

		// _CAOɓ\tĂFvxDisplayEx̃CX^X擾AX}[g|C^Ɋt܂B
		pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );		// FvxDisplayEx̃nh擾
		p_unknown = pwnd->GetControlUnknown();		// Rg[̎IUnknownC^[tFCX擾
		p_unknown->QueryInterface( __uuidof(IFvxDisplayEx2Ptr) , (void**)&m_FvxDisplayEx );

		// eFvxRg[̃CX^X𐶐܂B
		// w肷NXԈႦȂ悤ӂĂB
		m_FvxFileAccess.CreateInstance( __uuidof( FvxFileAccess ) ); 
		m_FvxImage1.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxImage2.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxImage3.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxImage4.CreateInstance( __uuidof( FvxImage ) ); 
		m_FvxVideo.CreateInstance( __uuidof( FvxVideo ) ); 
		m_FvxROI.CreateInstance( __uuidof( FvxROI ) ); 
		m_FvxPerformanceCounter.CreateInstance( __uuidof( FvxPerformanceCounter ) ); 
		m_FvxChangeImage.CreateInstance( __uuidof( FvxChangeImage ) ); 
		m_ExeRegion.CreateInstance( __uuidof( FvRectangle ) ); 

		// rfIfoCX̏ԂL
		m_blnVideoOpened = false;

		// fBXvC̏
		m_FvxDisplayEx->CreateDisplay( 1 , 0 );

		// 摜̕\
		m_FvxDisplayEx->DrawImage( m_FvxImage1 );

		// ͈͂̏lݒ(摜̑Sʂɐݒj
		m_ExeRegion->Putxs( -1 );
		m_ExeRegion->Putys( -1 );
		m_ExeRegion->Putxe( -1 );
		m_ExeRegion->Putye( -1 );

		// Rg[ނ̏
		CComboBox*    pcmb;
		pcmb = ( CComboBox* )GetDlgItem( IDC_AUTOBIN );
		pcmb->AddString( "OC`l" );
		pcmb->AddString( "J[`l" );
		pcmb->AddString( "J[̃OC摜ւ̕ϊ" );
		pcmb->AddString( "OC̃J[摜ւ̕ϊ" );
		m_autobin = 0;
	
		// Rg[ނ̏
		pcmb = ( CComboBox* )GetDlgItem( IDC_DISPIMAGE );
		pcmb->AddString( "摜1" );
		pcmb->AddString( "摜2" );
		pcmb->AddString( "摜3" );
		pcmb->AddString( "摜4" );
		m_dispimage = 0;
		
		UpdateData( FALSE ); 
    	OnSelchangeAutobin();

		// rfIݒt@C̑I
		fdlg.DoModal();

		if ( fdlg.m_check == FALSE ) {
			
		    // rfIݒt@CR|[lgɐݒ
 			m_FvxVideo->PutVideoConfFile( _bstr_t( fdlg.m_conffile ));

			// rfIfoCXI[v
			try {

				m_FvxVideo->OpenDevice();

			} catch( _com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfIfoCX̃I[vɎs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
			}

			// VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
			// ̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
			// {vOł͊ȗ̂߂ɁAꗥ350ms̃ZbgAbv^CmۂĂ܂A
			// g̃Lv`{[hɍ킹ĕύXĂB
			::Sleep( 350 );

			// GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
            // 炩ChangeImageSize\bhɂImagẽTCYύXĂ
            //i荞݃TCYImagẽTCYႤꍇG[ɂȂ܂j
			m_FvxVideo->ChangeImageSize( m_FvxImage1 );

            // ̉摜`Ɋi[C[W̃TCY낦Ă
            m_FvxImage2->PutImageType( m_FvxImage1->GetImageType() );
            m_FvxImage2->PutImageHeight( m_FvxImage1->GetImageHeight() );
            m_FvxImage2->PutImageWidth( m_FvxImage1->GetImageWidth() );

			try	{

				// 捞
				m_FvxVideo->GrabSync( m_FvxImage1 );

			} catch(_com_error ) {
			
				m_FvxVideo->GetErrReport( &err_no );
				MessageBox("rfI̎捞Ɏs܂\r\n摜t@Ĉ݂̗pɂȂ܂B" , "G[" , MB_ICONWARNING | MB_OK );
				return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B

			}

			// rfIfoCX̏ԂL
			m_blnVideoOpened = true;
	    	OnSelchangeAutobin();

		}

	}else{

		// ӂĂ炦Ȃ瑦I
		EndDialog( IDCANCEL );
	}
	
	UpdateData( FALSE ); 
	return TRUE;  // TRUE ԂƃRg[ɐݒ肵tH[JX͎܂B
}

void CChangeImageDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// _CAO{bNXɍŏ{^ǉȂ΁AACR`悷
// R[hȉɋLqKv܂BMFC AvP[V document/view
// fgĂ̂ŁȀ̓t[[Nɂ莩Iɏ܂B

void CChangeImageDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // `p̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// NCAg̋`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR`悵܂B
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// VXéA[U[ŏEBhEhbOĂԁA
// J[\\邽߂ɂĂяo܂B
HCURSOR CChangeImageDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BOOL CChangeImageDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: ̈ʒuɌŗL̏ǉ邩A܂͊{NXĂяoĂ
	if(pMsg->message == WM_KEYDOWN)
	{
		switch( pMsg->wParam )
		{
			case VK_RETURN:
			case VK_ESCAPE:
				return false;
		}
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}

void CChangeImageDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
	if (IsIconic() == 0 ) {

		if ( m_FvxDisplayEx != NULL ){

			CWnd *pwnd;
			CRect rect;

			pwnd = GetDlgItem( IDC_FVXDISPLAYEX1 );
			pwnd->GetWindowRect( rect );

			// XN[WNCAgWɕϊ
			ScreenToClient( rect );

			// FvxDisplayEx̃TCYύX
			pwnd->MoveWindow( rect.left , rect.top, cx - (rect.left + 20) , cy - (rect.top + 20) , TRUE );

		}
	}
}

// 摜t@Cۑ
void CChangeImageDlg::OnSaveimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg(FALSE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

		m_FvxFileAccess->PutFilePath ( _bstr_t(cFileDlg.GetPathName()) );

		try {
		
			UpdateData( TRUE );
			
			// Iꂽt@Cۑ
			switch ( m_dispimage ) {
				case 0:	 // 摜1
					m_FvxFileAccess->SaveBitmap( m_FvxImage1 );
					break;
				case 1:	// 摜2
					m_FvxFileAccess->SaveBitmap( m_FvxImage2 );
					break;
				case 2:	// 摜3
					m_FvxFileAccess->SaveBitmap( m_FvxImage3 );
					break;
				case 3:	// 摜4
					m_FvxFileAccess->SaveBitmap( m_FvxImage4 );
					break;
			}
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("ۑɎs܂Berr_no = %d", lngErr );
			MessageBox(cStr , "G[", MB_ICONWARNING | MB_OK);
			return;
		}
	}	
}

// I
void CChangeImageDlg::OnSelchangeAutobin() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	
    UpdateData( TRUE );
	
	m_staticparam1 = "Param1";
	m_staticparam2 = "Param2"; 
	m_staticparam3 = "Param3";

	GetDlgItem( IDC_STATICPARAM1 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_STATICPARAM2 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_STATICPARAM3 )->ShowWindow( SW_HIDE );

	m_param1 = 0;
	m_param2 = 0;
	m_param3 = 0;

	GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PARAM2 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_PARAM3 )->ShowWindow( SW_HIDE );

	GetDlgItem( IDC_BUTTON1 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_BUTTON2 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_BUTTON3 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_BUTTON4 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_BUTTON5 )->ShowWindow( SW_HIDE );
	GetDlgItem( IDC_BUTTON6 )->ShowWindow( SW_HIDE );

	switch ( m_autobin ) {
		case 0 :  // OC`l
			if ( !m_blnVideoOpened ) {
				GetDlgItem( IDC_BUTTON1 )->ShowWindow( SW_SHOW );
				GetDlgItem( IDC_BUTTON2 )->ShowWindow( SW_SHOW );
				GetDlgItem( IDC_BUTTON3 )->ShowWindow( SW_SHOW );
			} else {
				GetDlgItem( IDC_BUTTON4 )->ShowWindow( SW_SHOW );
				GetDlgItem( IDC_BUTTON5 )->ShowWindow( SW_SHOW );
				GetDlgItem( IDC_BUTTON6 )->ShowWindow( SW_SHOW );
				}
			break;
		case 1 : // J[`l
			GetDlgItem( IDC_BUTTON1 )->ShowWindow( SW_SHOW );
			break;
		case 2 :  // J[摜̔ZW摜ւ̕ϊ

			m_staticparam1 = "Red";
			m_param1 = 299;
			m_staticparam2 = "Green"; 
			m_param2 = 587;
			m_staticparam3 = "Blue";
			m_param3 = 144;

			GetDlgItem( IDC_STATICPARAM1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_STATICPARAM2 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_STATICPARAM3 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM1 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM2 )->ShowWindow( SW_SHOW );
			GetDlgItem( IDC_PARAM3 )->ShowWindow( SW_SHOW );

			if  ( !m_blnVideoOpened ) {
				GetDlgItem( IDC_BUTTON1 )->ShowWindow( SW_SHOW );
			} else {
				GetDlgItem( IDC_BUTTON4 )->ShowWindow( SW_SHOW );
			}
			break;
						
		case 3 : // ZW摜J[ւ̕ϊ
			if ( !m_blnVideoOpened ) {
				GetDlgItem( IDC_BUTTON1 )->ShowWindow( SW_SHOW );
			} else {
				GetDlgItem( IDC_BUTTON4 )->ShowWindow( SW_SHOW );
			}
			break;
	}
		
	UpdateData( FALSE );

}


void CChangeImageDlg::OnSelchangeDispimage() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ

	UpdateData( TRUE );

	// hbv_EXgChangeCxgȂ
    switch ( m_dispimage ) {
		case 0 :  // 摜1
		    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
			break;
		case 1 :  // 摜2
		    m_FvxDisplayEx->DrawImage( m_FvxImage2 );
			break;
		case 2 :  // 摜3
		    m_FvxDisplayEx->DrawImage( m_FvxImage3 );
			break;
		case 3 :  // 摜4
		    m_FvxDisplayEx->DrawImage( m_FvxImage4 );
			break;
	}
}

// 摜t@CǍ
void CChangeImageDlg::OnButton1() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	UpdateData( TRUE );

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

        // FileAccessR|[lgpāA
        // t@CImageɉ摜ǂݍ݂܂
		m_FvxFileAccess->PutFilePath( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImage1 );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

        if (( m_autobin == 0 ) || ( m_autobin == 3 )) {
            // 摜^Cv`FbN
            if (( m_FvxImage1->GetBitPerPixel() != 8 ) || ( m_FvxImage1->GetImageType()!=imageGray )) {
				MessageBox("8bitOC̉摜ł͂܂","G[", MB_ICONWARNING | MB_OK);
			}
		} else {
			// 摜^Cv`FbN
			if  (( m_FvxImage1->GetBitPerPixel() != 32 ) || ( m_FvxImage1->GetImageType() != imageRGB )) {
				MessageBox("J[摜ł͂܂","G[", MB_ICONWARNING | MB_OK);
			}               
		}
        m_FvxDisplayEx->DrawImage( m_FvxImage1 );
	}
	
}

// 摜t@CǍ
void CChangeImageDlg::OnButton2() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	// R_CAONX̐
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	UpdateData( TRUE );

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

        // FileAccessR|[lgpāA
        // t@CImageɉ摜ǂݍ݂܂
		m_FvxFileAccess->PutFilePath( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImage2 );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

        if (( m_autobin == 0 ) || ( m_autobin == 3 )) {
            // 摜^Cv`FbN
            if (( m_FvxImage1->GetBitPerPixel() != 8 ) || ( m_FvxImage1->GetImageType()!=imageGray )) {
				MessageBox("8bitOC̉摜ł͂܂","G[", MB_ICONWARNING | MB_OK);
			}
		} else {
			// 摜^Cv`FbN
			if  (( m_FvxImage1->GetBitPerPixel() != 32 ) || ( m_FvxImage1->GetImageType() != imageRGB )) {
				MessageBox("J[摜ł͂܂","G[", MB_ICONWARNING | MB_OK);
			}               
		}
        m_FvxDisplayEx->DrawImage( m_FvxImage2 );
	}
}

// 摜t@CǍ
void CChangeImageDlg::OnButton3() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
	char szFilters[]="bitmap file(*.bmp)|*.bmp||";
	char szIniFilePath[_MAX_PATH];

	UpdateData( TRUE );

	// spX擾
	::GetModuleFileName(GetModuleHandle(NULL), szIniFilePath, _MAX_PATH);

	CFileDialog cFileDlg (TRUE , "bmp", NULL , OFN_FILEMUSTEXIST| OFN_HIDEREADONLY, szFilters, this);
	cFileDlg.m_ofn.lpstrInitialDir = szIniFilePath ;

	if (cFileDlg.DoModal() == IDOK){

        // FileAccessR|[lgpāA
        // t@CImageɉ摜ǂݍ݂܂
		m_FvxFileAccess->PutFilePath( _bstr_t( cFileDlg.GetPathName() ) );

		try {
		
			m_FvxFileAccess->LoadBitmap( m_FvxImage3 );
		
		} catch(_com_error ) {

			long lngErr = 0;
			CString cStr;

			m_FvxFileAccess->GetErrReport( &lngErr );
			cStr.Format("Ǎ݂Ɏs܂Berr_no = %d", lngErr );
			MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
			return;
		}

        if (( m_autobin == 0 ) || ( m_autobin == 3 )) {
            // 摜^Cv`FbN
            if (( m_FvxImage1->GetBitPerPixel() != 8 ) || ( m_FvxImage1->GetImageType()!=imageGray )) {
				MessageBox("8bitOC̉摜ł͂܂","G[", MB_ICONWARNING | MB_OK);
                m_FvxImage1->PutBitPerPixel( 8 );
                m_FvxImage1->PutImageType( imageGray );
			}
		} else {
			// 摜^Cv`FbN
			if  (( m_FvxImage1->GetBitPerPixel() != 32 ) || ( m_FvxImage1->GetImageType() != imageRGB )) {
				MessageBox("J[摜ł͂܂","G[", MB_ICONWARNING | MB_OK);
			}               
		}
        m_FvxDisplayEx->DrawImage( m_FvxImage3 );
	}
}

// 摜t@C荞
void CChangeImageDlg::OnButton4() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    // 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂B
    m_FvxVideo->ChangeImageSize( m_FvxImage1 );

    // 捞
    m_FvxVideo->GrabSync( m_FvxImage1 );
    // 荞񂾉摜ʂɕ\
    m_FvxDisplayEx->DrawImage( m_FvxImage1 );
	
}

// 摜t@C荞
void CChangeImageDlg::OnButton5() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    // 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂B
    m_FvxVideo->ChangeImageSize( m_FvxImage2 );

    // 捞
    m_FvxVideo->GrabSync( m_FvxImage2 );
    // 荞񂾉摜ʂɕ\
    m_FvxDisplayEx->DrawImage( m_FvxImage2 );
	
}

void CChangeImageDlg::OnButton6() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    // 摜t@Cǂݍ݂ɂāA摜TCY
    // ύXĂ\邽߁AChangeImageSizes܂B
    // 摜TCYύX\ꍇ́AɈxsΖL܂B
    m_FvxVideo->ChangeImageSize( m_FvxImage3 );

    // 捞
    m_FvxVideo->GrabSync( m_FvxImage3 );
    // 荞񂾉摜ʂɕ\
    m_FvxDisplayEx->DrawImage( m_FvxImage3 );

}

// s
void CChangeImageDlg::OnExecute() 
{
	// TODO: ̈ʒuɃRg[ʒmnhp̃R[hǉĂ
    
    if (!UpdateData( TRUE )) return;
 
	// Rg[ނ̏
	CComboBox*    pcmb;
	pcmb = ( CComboBox* )GetDlgItem( IDC_DISPIMAGE );
	pcmb->ResetContent();

	try {

		switch ( m_autobin ) {
			case 0 :   // OC`l     FvxImage1:Red  FvxImage2:Green  FvxImage3:Blue

		        // o͏R{{bNXɐݒ
				pcmb->AddString( "摜1" );
				pcmb->AddString( "摜2" );
				pcmb->AddString( "摜3" );
				pcmb->AddString( "摜4" );

				// o͑̃C[WNA
				m_FvxImage4->ClearImage();
    
				m_FvxPerformanceCounter->StartCount();
				m_FvxChangeImage->CompoundGray( m_FvxImage1, m_FvxImage2, m_FvxImage3, m_FvxImage4 );
				double dblTime;
				m_FvxPerformanceCounter->StopCount( &dblTime );
				m_FvxDisplayEx->DrawImage( m_FvxImage4 );
				m_dispimage = 3;
    			m_executetime.Format("%fms", dblTime );
				break;
			case 1 :  // J[`l

		        // o͏R{{bNXɐݒ
				pcmb->AddString( "摜1" );
				pcmb->AddString( "摜2" );
				pcmb->AddString( "摜3" );
				pcmb->AddString( "摜4" );

				// o͑̃C[WNA
				m_FvxImage2->ClearImage();
				m_FvxImage3->ClearImage();
				m_FvxImage4->ClearImage();

				m_FvxPerformanceCounter->StartCount();
				m_FvxChangeImage->DecomposeColor( m_FvxImage1, m_FvxImage2, m_FvxImage3, m_FvxImage4 );
				m_FvxPerformanceCounter->StopCount( &dblTime );
        
				m_FvxDisplayEx->DrawImage( m_FvxImage2 );
				m_dispimage = 1;
    			m_executetime.Format("%fms", dblTime );
				break;

			case 2 :  // J[摜̔ZW摜ւ̕ϊ

		        // o͏R{{bNXɐݒ
				pcmb->AddString( "摜1" );
				pcmb->AddString( "摜2" );

				//o͑̃C[WNA
				m_FvxImage2->ClearImage();
        
				m_FvxPerformanceCounter->StartCount();
				m_FvxChangeImage->ColorToGray( m_FvxImage1, m_FvxImage2, m_param1 * 0.001, m_param2 * 0.001, m_param3 * 0.001 );
				m_FvxPerformanceCounter->StopCount( &dblTime );
        
				m_FvxDisplayEx->DrawImage( m_FvxImage2 );
				m_dispimage = 1;
    			m_executetime.Format("%fms", dblTime );
				break;
			case 3 :  // ZW摜̃J[摜ւ̕ϊ
		
		        // o͏R{{bNXɐݒ
				pcmb->AddString( "摜1" );
				pcmb->AddString( "摜2" );
				
				// o͑̃C[WNA
				m_FvxImage2->ClearImage();
        
				long value = 0;
				long pdPalette[256]	;	// pbg̒`
				for ( int  i = 0 ; i <= 255 ; i++ ) {
					value = 255 - i;
					pdPalette[i] = (((unsigned int)value) << 16) + (((unsigned int)value) << 8 ) + ((unsigned int)i);
				}

				m_FvxPerformanceCounter->StartCount();
				m_FvxChangeImage->GrayToColor( m_FvxImage1, m_FvxImage2, 256, pdPalette);
				m_FvxPerformanceCounter->StopCount( &dblTime );
        
				m_FvxDisplayEx->DrawImage( m_FvxImage2 );
    			m_executetime.Format("%fms", dblTime );
				m_dispimage = 1;
				break;
		}

		UpdateData( FALSE );

	} catch (_com_error) {

	long lngErr = 0;
	CString cStr;

		m_FvxChangeImage->GetErrReport( &lngErr );

		switch ( lngErr ) {
			case 0:
				cStr.Format("G[");
				break;
			case 1501:
				cStr.Format("Ɏs܂B err_no = %d", lngErr );
				break;
			case 1505:
				cStr.Format("p[^Ⴂ܂B err_no = %d", lngErr );
				break;
			case 1506:
				cStr.Format("̌^Ⴂ܂B err_no = %d", lngErr );
				break;
			case 1531:
				cStr.Format("ΏۃC[ŴwTCÝA32̔{łȂ΂Ȃ܂B  err_no = %d", lngErr );
				break;
			case 1532:
				cStr.Format("ΏۃC[Wƌʊi[C[ẂATCYłȂ΂Ȃ܂Berr_no = %d", lngErr );
				break;
			case 1550:
				cStr.Format("C[W̎ނႢ܂B err_no = %d", lngErr );
				break;
			case 1551:
				cStr.Format("ΏۃC[Wƌʊi[C[WɁÃIuWFNgw肳Ă܂Berr_no = %d", lngErr );
				break;
			case 1552:
				cStr.Format("͈͂̎wɊԈႢ܂Berr_no = %d", lngErr );
				break;
			default:
				cStr.Format("sȃG[ err_no = %d", lngErr );
				break;
		}

		MessageBox(cStr,"G[", MB_ICONWARNING | MB_OK);
		return;
	}
}

// pbg̍쐬
//DEL long CChangeImageDlg::RevRGB(long red, long green, long blue)
//DEL {
//DEL 	return  blue + (green * 256) + (red * 65536);
//DEL }

// ep[^̓Kp

void CChangeImageDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: ̈ʒuɃbZ[W nhp̃R[hǉĂ
    // rfIfoCXI[vĂꍇ̓N[Y܂
	if ( m_blnVideoOpened == true ) {
		m_FvxVideo->CloseDevice();	
	}
	
}
